//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "Word_XP_srvr"
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
// Julian century depuis 01/01/2000  12h UT
double JulianCentury (int date, int month, int year, double UT)
{
	if (month<=2) {month=month+12; year=year-1;}
  return ((int)(365.25*year) + (int)(30.6001*(month+1)) - 15 + 1720996.5 + date + UT/24.0 - 2451545.0)/36525.0;
} 
//---------------------------------------------------------------------------
int CalculeNjdumois(int m, int annee)
{
int Nonbissextile=(annee-4*(int)(annee/4)+2)/3;  // 1 pour une anne commune et  0 pour une bissextile)
	if (m==1 || m==3 || m==5 || m==7
	 || m==8 || m==10 || m==12) 	return 31;
			else	{
						if (m==2) {if (Nonbissextile) return 28;
															else				return 29;
											}
								else  return 30;
				}
}
//---------------------------------------------------------------------------
int CalculeJour(double T) //  pertir du siecle Julien
{
double jour=T*36525+5;   
	return jour-7*(int)(jour/7);
}
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
	Mounths[0]="Janvier";
	Mounths[1]="Fvrier";
	Mounths[2]="Mars";
	Mounths[3]="Avril";
	Mounths[4]="Mai";
	Mounths[5]="Juin";
	Mounths[6]="Juillet";
	Mounths[7]="Aot";
	Mounths[8]="Septembre";
	Mounths[9]= "Octobre";
	Mounths[10]="Novembre";
	Mounths[11]="Dcembre";
	Days[0]="Lundi";
	Days[1]="Mardi";
	Days[2]="Mercredi";
	Days[3]="Jeudi";
	Days[4]="Vendredi";
	Days[5]="Samedi";
	Days[6]="Dimanche";
	for (int i=1950; i<2050; i++)
		CBAnnee->Items->Add(i);
	CBAnnee->ItemIndex=2007-1950;	// place la slection sur 2007 !!!
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ButtonGenereClick(TObject *Sender)
{
int annee, mois, jour;
double T;  // Siecle Julien : T, 
int erreur, Nj[12], IndexM[12], stdcolor, C ,i;
double ratio;
int	daysAnnuel[12][31];
AnsiString FileName, FilePath;
Table * Table1;
//OleVariant Template, AsModel;

	annee=CBAnnee->ItemIndex+1950;
	for (mois=1; mois<=12; mois++)
		{
		Nj[mois-1]=CalculeNjdumois( mois, annee);
		for (jour=1; jour<=Nj[mois-1];jour++)
			{
			T=JulianCentury (jour, mois, annee, 12);    // pour 12h
//			daysAnnuel[mois-1][jour-1]=CalculeJour((T)/24.0/36525.0);  // juste pour le jour (Lundi, mardi...)
			daysAnnuel[mois-1][jour-1]=CalculeJour(T+(1+12)/24.0/36525.0);  // juste pour le jour (Lundi, mardi...) 1 : Time Zone
			}
		}
// Cree un fichier Word
	FilePath=ExtractFilePath(Application->ExeName);
	FileName=FilePath+"Calendrier_"+AnsiString(annee)+".doc";

// Lance Word ou se connecte  un word existant
	WordApplication1->Connect();
	WordApplication1->Visible=true;
// Cree un fichier Word
	WordDocument1-> Connect();
// ou alors	WordDocument1-> ConnectTo(WordApplication1->Documents->AddOld( Template, AsModel));      // utilise le template
	WordDocument1->SaveAs(  (Variant)WideString(FileName));  // ici on sauve un document
	// on prepare la Font du texte
	WordApplication1->Selection->ParagraphFormat->Alignment=wdAlignParagraphCenter;
	WordApplication1->Selection->Font->Name=WideString("Verdana");
	WordApplication1->Selection->Font->Size=20;
	// on insere du texte
	WordApplication1->Selection->TypeText(WideString("Calendrier" + IntToStr(annee)));
	// on fait un passage a la ligne suivante
	WordApplication1->Selection->TypeParagraph();
	WordApplication1->Selection->Font->Size=8;
	WordApplication1->Selection->TypeText(WideString("Generated by Lotfi "));
	WordApplication1->Selection->TypeParagraph();
	WordApplication1->Selection->TypeParagraph();
	WordApplication1->Selection->TypeParagraph();

	InlineShape * Shape=WordApplication1->Selection->InlineShapes->AddPicture(	WideString(FilePath+"3.jpg"),
																																						 (OleVariant)false, (OleVariant)true, EmptyParam);
	Shape->LockAspectRatio = msoTrue;
	if (Shape->Height!=0)	ratio=200.0/Shape->Height;
					else 					ratio=1;
	Shape->Height *=ratio;
	Shape->Width *=ratio;
	WordApplication1->Selection->TypeParagraph();
	WordApplication1->Selection->TypeText(WideString("El masdjed ennabawi, el Madina el mounawara"));
	WordApplication1->Selection->TypeParagraph();
	WordApplication1->Selection->TypeParagraph();

// table du calendrier
	for (i=0; i<4; i++)   // cre en 4 tables de 3 colonnes
		{
		// on insere un tableau 8 lignes 24 colonnes
		Table1=WordDocument1->Tables->AddOld(  WordApplication1->Selection->Range, 8, 24);
		Table1->Rows->SetLeftIndent( 12.5, wdAdjustNone);
			// Bold et couleur l'intitul des mois et jours:
////				Table1.OlePropertyGet("Rows").OleFunction("Item", "1").OleFunction("Select");
////				vMSWord.OlePropertyGet("Selection").OlePropertyGet("Font").OlePropertySet("Color",wdColorDarkTeal);
			Table1->Rows->Item(1)->Select();
			WordApplication1->Selection->Font->Color=wdColorDarkBlue;
// idem de	MyRange->SetRange( Table1->Rows->Item(1)->Range->Start, Table1->Rows->Item(1)->Range->End);
//			MyRange->Font->Color=wdColorDarkBlue;

			Table1->Rows->Item(1)->Select();
			WordApplication1->Selection->Font->Bold=true;
			WordApplication1->Selection->MoveDown( (OleVariant)wdLine, (OleVariant)1, (OleVariant)wdExtend);
			WordApplication1->Selection->Font->Bold=true;
// idem de  MyRange->SetRange( Table1->Rows->Item(1)->Range->Start, Table1->Rows->Item(2)->Range->End);
////			MyRange = WordDocument1->OleFunction("Range", Table1.OlePropertyGet("Rows").OleFunction("Item", "1").OlePropertyGet("Range").OlePropertyGet("Start"),
////																								Table1.OlePropertyGet("Rows").OleFunction("Item", "2").OlePropertyGet("Range").OlePropertyGet("End"));
//			MyRange->Font->Bold=true;
		for (mois=1+3*i; mois<=3+3*i; mois++)   // entete des mois
			{
			C=8*(mois-1-3*i)+1;
			IndexM[mois-1]=1;	// debut du mois
			Table1->Cell(1,C)->Range->InsertAfter( WideString(Mounths[mois-1].c_str()+AnsiString(" ")+annee));
			Table1->Cell(2,C+0)->Range->InsertAfter(WideString("L"));
			Table1->Cell(2,C+1)->Range->InsertAfter(WideString("M"));
			Table1->Cell(2,C+2)->Range->InsertAfter(WideString("M"));
			Table1->Cell(2,C+3)->Range->InsertAfter(WideString("J"));
			Table1->Cell(2,C+4)->Range->InsertAfter(WideString("V"));
			Table1->Cell(2,C+5)->Range->InsertAfter(WideString("S"));
			Table1->Cell(2,C+6)->Range->InsertAfter(WideString("D"));

			for (int semaine=0; semaine<6; semaine++)
				for (int JourSemaine=0; JourSemaine<7; JourSemaine++)
					{
					if ( (JourSemaine >= daysAnnuel[mois-1][IndexM[mois-1]-1] || IndexM[mois-1]!=1)
								&&  IndexM[mois-1] <= Nj[mois-1] )
										{
										Table1->Cell(3+semaine,C+JourSemaine)->Range->InsertAfter(WideString( IndexM[mois-1]));
//											Table1.OleFunction( "Cell", 3+semaine, C+JourSemaine ).OlePropertyGet( "Range" ).OleFunction("InsertAfter", IndexM[mois-1]);
										IndexM[mois-1]++;
										}
					}
			// colore la colonne vendredi et dimanche
			Table1->Cell(2,C+4)->Select();
			WordApplication1->Selection->MoveDown( (OleVariant)wdLine, (OleVariant)5, (OleVariant)wdExtend);
			WordApplication1->Selection->Font->Color=wdColorBlue;
			Table1->Cell(2,C+6)->Select();
			WordApplication1->Selection->MoveDown( (OleVariant)wdLine, (OleVariant)5, (OleVariant)wdExtend);
			WordApplication1->Selection->Font->Color=wdColorRed;
			} //for (mois=1+3*i...
		// fusionne l'intitul des mois :
			Table1->Cell(1,1)->Merge( Table1->Cell(1, 7));
			Table1->Cell(1,3)->Merge( Table1->Cell(1, 9));
			Table1->Cell(1,5)->Merge( Table1->Cell(1, 11));
				// atteint la fin du fichier
			WordApplication1->Selection->EndKey((OleVariant)wdStory, (OleVariant)wdMove);
			WordApplication1->Selection->TypeParagraph();		WordApplication1->Selection->TypeParagraph();
			} //for (int i=0; i<4; i++)

	WordDocument1->Save();  // ici on sauve un document
	if (Application->MessageBoxA("Cliquez pour fermer", "Debug",	MB_YESNO)==IDYES)	WordDocument1->Close();  // on ferme le document
//	WordApplication1->Quit();   // on ferme Word
//---------------------------------------------------------------------------
}
